import { EventEmitter } from '../../stencil-public-runtime';
import { DeckdeckgoDeckDefinition, DeckdeckgoSlideDefinition } from '@deckdeckgo/types';
export declare class DeckGoDeck {
  el: HTMLElement;
  keyboard: boolean;
  embedded: boolean;
  cloneBackground: boolean;
  private rtl;
  private startX;
  private startY;
  private deckMove;
  private autoSwipeRatio;
  private block;
  private activeIndex;
  private length;
  slidesDidLoad: EventEmitter;
  slideNextDidAnimate: EventEmitter<void>;
  slidePrevDidAnimate: EventEmitter<void>;
  slideNextDidChange: EventEmitter<number>;
  slidePrevDidChange: EventEmitter<number>;
  slideToChange: EventEmitter<number>;
  slideDrag: EventEmitter<number>;
  slideWillChange: EventEmitter<number>;
  deckDidLoad: EventEmitter<void>;
  private fullscreen;
  private cursorHidden;
  private idleMouseTimer;
  private readonly idleMouseTimeout;
  mouseInactivity: EventEmitter<boolean>;
  reveal: boolean;
  revealOnMobile: boolean;
  animation: 'slide' | 'fade' | 'none';
  direction: 'horizontal' | 'vertical' | 'papyrus';
  directionMobile: 'horizontal' | 'vertical' | 'papyrus';
  autoSlide: 'true' | 'false';
  autoSlideInterval: number;
  private dir;
  private observer;
  private slideLoopInterval;
  private idleSlideLoopTimer;
  private mobile;
  private containerRef;
  private readonly debounceWindowResize;
  componentWillLoad(): Promise<void>;
  componentDidLoad(): Promise<void>;
  disconnectedCallback(): void;
  private initRtl;
  private initWindowResize;
  initSlideSize(): Promise<void>;
  private initSlideSizeStandard;
  private containerSize;
  private initSlideSizeEmbedded;
  private initFontSize;
  private initKeyboardAssist;
  private initLazyLoadContent;
  private deferIntersectionObserverLoad;
  private onIntersection;
  toggleKeyboardAssist(state: boolean): Promise<void>;
  private keyboardAssist;
  onDirectionMobileChange(): Promise<void>;
  onDirectionChange(): Promise<void>;
  private initDirection;
  mousedown($event: MouseEvent): void;
  touchstart($event: TouchEvent): void;
  mouseup($event: MouseEvent): Promise<void>;
  touchend($event: TouchEvent): Promise<void>;
  mousemove($event: MouseEvent): Promise<void>;
  touchmove($event: TouchEvent): Promise<void>;
  dblclick(): Promise<void>;
  contextMenu(): Promise<void>;
  scrolling($event: CustomEvent): void;
  keypress(): Promise<void>;
  private start;
  private move;
  private moveX;
  private moveY;
  private stop;
  private swipeSlide;
  private isNextChange;
  private doSwipeSlide;
  private resetStart;
  private getDelta;
  slideDidLoad(): Promise<void>;
  private updateLength;
  private afterSlidesDidLoad;
  private onAllSlidesDidLoad;
  getDeckDefinition(): Promise<DeckdeckgoDeckDefinition | null>;
  getSlideDefinition(index: number): Promise<DeckdeckgoSlideDefinition | null>;
  private getDefinedFilteredSlides;
  loadBackground(): Promise<void>;
  loadHeader(): Promise<void>;
  loadFooter(): Promise<void>;
  private loadSlots;
  private filterSlides;
  isBeginning(): Promise<boolean>;
  isEnd(): Promise<boolean>;
  getActiveIndex(): Promise<number>;
  getLength(): Promise<number>;
  slideNext(slideAnimation?: boolean, emitEvent?: boolean): Promise<void>;
  slidePrev(slideAnimation?: boolean, emitEvent?: boolean): Promise<void>;
  private slideNextPrev;
  private beforeSwipe;
  private afterSwipe;
  private lazyLoadContent;
  slideTo(index: number, speed?: number | undefined, emitEvent?: boolean): Promise<void>;
  deleteActiveSlide(removeChild?: boolean): Promise<void>;
  blockSlide(block: boolean): Promise<void>;
  toggleFullScreen(): Promise<void>;
  private hideOrClearMouseCursorTimer;
  private clearMouseCursorTimer;
  private hideMouseCursorWithDelay;
  private showHideMouseCursor;
  private showHideActionsSlot;
  doPrint(): Promise<void>;
  lazyLoadAllContent(): Promise<void[]>;
  onRevealChange(): Promise<void>;
  private revealAllContent;
  private redoRevealContent;
  private revealContent;
  private hideContent;
  private initAutoSlide;
  onAutoSlide(): Promise<void>;
  render(): any;
  private renderAnimation;
}
